# This is an RPM spec file that specifies how to package
# haddock for Red Hat Linux and, possibly, similar systems.
# It has been tested on Red Hat Linux 7.2 and SuSE Linux 9.1.
#
# If this file is part of a tarball, you can build RPMs directly from
# the tarball by using the following command:
#
#    rpm -ta haddock-(VERSION).tar.gz
#
# The resulting package will be placed in the RPMS/(arch) subdirectory
# of your RPM build directory (usually /usr/src/redhat or ~/rpm), with
# the name haddock-(VERSION)-(RELEASE).noarch.rpm.  A corresponding
# source RPM package will be in the SRPMS subdirectory.
#
# NOTE TO HADDOCK MAINTAINERS: When you release a new version of
# Haskell mode, update the version definition below to match the
# version label of your release tarball.

Name:           haddock
Version:        2.0.0.0
Release:        1%{?dist}
License:        BSD-like
Group:          Development/Languages/Haskell
URL:            http://haskell.org/haddock/
Source:         http://haskell.org/haddock/dist/haddock-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Prefix:         %{_prefix}
BuildRequires:  ghc, docbook-dtds, docbook-style-xsl, libxslt, libxml2, fop, xmltex, tetex-dvips
Summary:        A documentation tool for annotated Haskell source code

%define ghc_ver %(ghc --numeric-version)
%define _libsubdir ghc-%{ghc_ver}/lib

%description
Haddock is a tool for automatically generating documentation from
annotated Haskell source code. It is primary intended for documenting
libraries, but it should be useful for any kind of Haskell code.

Haddock lets you write documentation annotations next to the
definitions of functions and types in the source code, in a syntax
that is easy on the eye when writing the source code (no heavyweight
mark-up). The documentation generated by Haddock is fully hyperlinked
-- click on a type name in a type signature to go straight to the
definition, and documentation, for that type.

Haddock can generate documentation in multiple formats; currently HTML
is implemented, and there is partial support for generating DocBook.
The generated HTML uses stylesheets, so you need a fairly up-to-date
browser to view it properly (Mozilla, Konqueror, Opera, and IE 6
should all be ok).

%package     devel
Summary:     Development files for %{name}
Requires:    ghc = %{ghc_ver}
Group:          Development/Languages/Haskell

%description devel
Development files for %{name}

%prep
%setup

%build
runhaskell Setup.lhs configure --prefix=%{_prefix} --docdir=%{_docdir}/%{name}-%{version} --libdir=%{_libdir} --libexecdir=%{_libexecdir} --datadir=%{_datadir} --libsubdir=%{_libsubdir}
runhaskell Setup.lhs build
cd doc
test -f configure || autoreconf
%configure
make html

%install
rm -rf ${RPM_BUILD_ROOT}
runhaskell Setup.lhs copy --destdir=${RPM_BUILD_ROOT}
mv ${RPM_BUILD_ROOT}/%{_libdir}/%{_libsubdir}/*HShaddock* ${RPM_BUILD_ROOT}/%{_libdir}/%{_libsubdir}/Haddock
rm -rf ${RPM_BUILD_ROOT}/%{_docdir}/packages

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc CHANGES LICENSE README TODO
%doc doc/haddock
%doc examples
%doc haskell.vim
%{_prefix}/bin/haddock
%{_datadir}/haddock-%{version}

%files devel
%defattr(-,root,root)
%{_libdir}/%{_libsubdir}/Haddock
%{_libdir}/%{_libsubdir}/Distribution/Haddock.hi

%changelog
* Thu Apr 10 2008 Aleksey Nogin <rpm@nogin.org> 2.0.0.0-1.el5
- Updated for RHEL5/CentOS 5 based on the original spec by Sven Panne <sven.panne@aedion.de>
